/*global define:false require:false */
(function (name, context, definition) {
	if (typeof module != 'undefined' && module.exports) module.exports = definition();
	else if (typeof define == 'function' && define.amd) define(definition);
	else context[name] = definition();
})('jquery-slidescrollpanel', this, function() {
  var $, SlideScrollPanel, jQuery,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty;

  jQuery = $ = window.jQuery || require('jquery');

  $.SlideScrollPanel = SlideScrollPanel = (function() {
    SlideScrollPanel.prototype.config = {
      $el: null,
      $wrap: null,
      direction: 'right',
      autoContentWidth: true,
      autoContentHeight: true,
      autoWrapWidth: true,
      autoWrapHeight: true,
      disableDelay: 1 * 1000,
      wrapActiveClass: 'slidescrollpanel-active',
      wrapStyles: {
        margin: 0,
        padding: 0,
        position: 'absolute',
        top: 0,
        left: 0,
        overflow: 'auto',
        'z-index': 100
      },
      contentStyles: {
        margin: 0,
        padding: 0,
        width: '100%',
        display: 'inline-block'
      }
    };

    function SlideScrollPanel(opts) {
      var $content, $wrap, key, value;
      if (opts == null) {
        opts = {};
      }
      this.leavePanelHelper = __bind(this.leavePanelHelper, this);
      this.enterPanelHelper = __bind(this.enterPanelHelper, this);
      this.disable = __bind(this.disable, this);
      this.enable = __bind(this.enable, this);
      this.hidePanel = __bind(this.hidePanel, this);
      this.showPanel = __bind(this.showPanel, this);
      this.resize = __bind(this.resize, this);
      this.active = __bind(this.active, this);
      this.$getEl = __bind(this.$getEl, this);
      this.$getContent = __bind(this.$getContent, this);
      this.$getWrapper = __bind(this.$getWrapper, this);
      this.getHideAxisProperties = __bind(this.getHideAxisProperties, this);
      this.getShowAxisProperties = __bind(this.getShowAxisProperties, this);
      this.getAxisProperties = __bind(this.getAxisProperties, this);
      this.getHideAxisValue = __bind(this.getHideAxisValue, this);
      this.getShowAxisValue = __bind(this.getShowAxisValue, this);
      this.getAxisValue = __bind(this.getAxisValue, this);
      this.getAxisProperty = __bind(this.getAxisProperty, this);
      this.getHidePositionStyles = __bind(this.getHidePositionStyles, this);
      this.getShowPositionStyles = __bind(this.getShowPositionStyles, this);
      this.getDesiredPositionStyles = __bind(this.getDesiredPositionStyles, this);
      this.getPositionStyles = __bind(this.getPositionStyles, this);
      this.getDesiredPositionValue = __bind(this.getDesiredPositionValue, this);
      this.getHidePositionValue = __bind(this.getHidePositionValue, this);
      this.getShowPositionValue = __bind(this.getShowPositionValue, this);
      this.getPositionValue = __bind(this.getPositionValue, this);
      this.getPositionProperty = __bind(this.getPositionProperty, this);
      this.getDesiredMarginStyles = __bind(this.getDesiredMarginStyles, this);
      this.getMarginStyles = __bind(this.getMarginStyles, this);
      this.getDesiredMarginValue = __bind(this.getDesiredMarginValue, this);
      this.getMarginValue = __bind(this.getMarginValue, this);
      this.getMarginProperty = __bind(this.getMarginProperty, this);
      this.getSizeValue = __bind(this.getSizeValue, this);
      this.getSizeProperty = __bind(this.getSizeProperty, this);
      this.isInverse = __bind(this.isInverse, this);
      this.addListeners = __bind(this.addListeners, this);
      this.removeListeners = __bind(this.removeListeners, this);
      this.destroy = __bind(this.destroy, this);
      this.config = JSON.parse(JSON.stringify(this.config));
      for (key in opts) {
        if (!__hasProp.call(opts, key)) continue;
        value = opts[key];
        this.config[key] = value;
      }
      $content = this.config.$el;
      if (this.config.$wrap) {
        $wrap = this.config.$wrap;
      } else {
        $wrap = $("<div/>");
        $content.wrap($wrap);
        this.config.$wrap = $wrap = $content.parent();
      }
      $wrap.hide().data('slidescrollpanel', this).addClass("slidescrollpanel-wrap").css(this.config.wrapStyles);
      $content.data('slidescrollpanel', this).addClass("slidescrollpanel-content slidescrollpanel-direction-" + (this.getDirection())).css(this.config.contentStyles);
      this.addListeners();
      this;
    }

    SlideScrollPanel.prototype.destroy = function() {
      this.removeListeners();
      return this;
    };

    SlideScrollPanel.prototype.removeListeners = function() {
      if (this.isTouchDevice()) {
        this.$getWrapper().off('touchstart', this.enterPanelHelper).off('touchend', this.leavePanelHelper);
      } else {
        this.$getContent().off('mouseenter', this.enterPanelHelper).off('mouseleave', this.leavePanelHelper);
        this.$getWrapper().off('scroll', this.leavePanelHelper);
      }
      $(window).off('resize', this.resize);
      return this;
    };

    SlideScrollPanel.prototype.addListeners = function() {
      this.removeListeners();
      if (this.isTouchDevice()) {
        this.$getWrapper().on('touchstart', this.enterPanelHelper).on('touchend', this.leavePanelHelper);
      } else {
        this.$getContent().on('mouseenter', this.enterPanelHelper).on('mouseleave', this.leavePanelHelper);
        this.$getWrapper().on('scroll', this.leavePanelHelper);
      }
      $(window).on('resize', this.resize);
      return this;
    };

    SlideScrollPanel.prototype.isTouchDevice = function() {
      return !!('ontouchstart' in window) || !!('onmsgesturechange' in window);
    };

    SlideScrollPanel.prototype.getDirection = function() {
      return this.config.direction;
    };

    SlideScrollPanel.prototype.inverseMap = {
      right: false,
      left: true,
      top: true,
      bottom: false
    };

    SlideScrollPanel.prototype.isInverse = function() {
      var direction, inverse;
      direction = this.getDirection();
      inverse = this.inverseMap[direction];
      return inverse;
    };

    SlideScrollPanel.prototype.sizePropertyMap = {
      right: 'width',
      left: 'width',
      top: 'height',
      bottom: 'height'
    };

    SlideScrollPanel.prototype.getSizeProperty = function() {
      var direction, sizeProperty;
      direction = this.getDirection();
      sizeProperty = this.sizePropertyMap[direction];
      return sizeProperty;
    };

    SlideScrollPanel.prototype.getSizeValue = function() {
      var sizeProperty, sizeValue;
      sizeProperty = this.getSizeProperty();
      sizeValue = this.$getWrapper()['inner' + sizeProperty.substr(0, 1).toUpperCase() + sizeProperty.substr(1)]();
      return sizeValue;
    };

    SlideScrollPanel.prototype.marginPropertyMap = {
      right: 'margin-left',
      left: 'margin-right',
      top: 'margin-bottom',
      bottom: 'margin-top'
    };

    SlideScrollPanel.prototype.getMarginProperty = function() {
      var direction, marginProperty;
      direction = this.getDirection();
      marginProperty = this.marginPropertyMap[direction];
      return marginProperty;
    };

    SlideScrollPanel.prototype.getMarginValue = function() {
      var margin, marginProperty;
      marginProperty = this.getMarginProperty();
      margin = this.$getContent().css(marginProperty);
      return marginValue;
    };

    SlideScrollPanel.prototype.getDesiredMarginValue = function() {
      return this.getSizeValue();
    };

    SlideScrollPanel.prototype.getMarginStyles = function() {
      var opts;
      opts = {};
      opts[this.getMarginProperty()] = this.getMarginValue();
      return opts;
    };

    SlideScrollPanel.prototype.getDesiredMarginStyles = function() {
      var opts;
      opts = {};
      opts[this.getMarginProperty()] = this.getDesiredMarginValue();
      return opts;
    };

    SlideScrollPanel.prototype.positionPropertyMap = {
      right: 'left',
      left: 'left',
      top: 'top',
      bottom: 'top'
    };

    SlideScrollPanel.prototype.getPositionProperty = function() {
      var direction, positionProperty;
      direction = this.getDirection();
      positionProperty = this.positionPropertyMap[direction];
      return positionProperty;
    };

    SlideScrollPanel.prototype.getPositionValue = function() {
      var positionProperty, positionValue;
      positionProperty = this.getPositionProperty();
      positionValue = this.$getWrapper().css(positionProperty);
      return positionValue;
    };

    SlideScrollPanel.prototype.getShowPositionValue = function() {
      var positionValue;
      positionValue = '0px';
      return positionValue;
    };

    SlideScrollPanel.prototype.getHidePositionValue = function() {
      var positionValue;
      positionValue = this.getSizeValue() + 'px';
      return positionValue;
    };

    SlideScrollPanel.prototype.getDesiredPositionValue = function() {
      var positionValue;
      positionValue = (this.getShowAxisValue() - this.getAxisValue()) + 'px';
      return positionValue;
    };

    SlideScrollPanel.prototype.getPositionStyles = function() {
      var opts;
      opts = {};
      opts[this.getPositionProperty()] = this.getPositionValue();
      return opts;
    };

    SlideScrollPanel.prototype.getDesiredPositionStyles = function() {
      var opts;
      opts = {};
      opts[this.getPositionProperty()] = (this.getShowAxisValue() - this.getAxisValue()) + 'px';
      return opts;
    };

    SlideScrollPanel.prototype.getShowPositionStyles = function() {
      var opts;
      opts = {};
      opts[this.getPositionProperty()] = this.getShowPositionValue();
      return opts;
    };

    SlideScrollPanel.prototype.getHidePositionStyles = function() {
      var opts;
      opts = {};
      opts[this.getPositionProperty()] = this.getHidePositionValue();
      return opts;
    };

    SlideScrollPanel.prototype.axisPropertyMap = {
      right: 'scrollLeft',
      left: 'scrollLeft',
      top: 'scrollTop',
      bottom: 'scrollTop'
    };

    SlideScrollPanel.prototype.getAxisProperty = function() {
      var axisProperty, direction;
      direction = this.getDirection();
      axisProperty = this.axisPropertyMap[direction];
      return axisProperty;
    };

    SlideScrollPanel.prototype.getAxisValue = function() {
      var axisProperty, axisValue;
      axisProperty = this.getAxisProperty();
      axisValue = this.$getWrapper().prop(axisProperty);
      return axisValue;
    };

    SlideScrollPanel.prototype.getShowAxisValue = function() {
      var axisValue;
      axisValue = this.isInverse() ? 0 : this.getSizeValue();
      return axisValue;
    };

    SlideScrollPanel.prototype.getHideAxisValue = function() {
      var axisValue;
      axisValue = this.isInverse() ? this.getSizeValue() : 0;
      return axisValue;
    };

    SlideScrollPanel.prototype.getAxisProperties = function() {
      var opts;
      opts = {};
      opts[this.getAxisProperty()] = this.getAxisValue();
      return opts;
    };

    SlideScrollPanel.prototype.getShowAxisProperties = function() {
      var opts;
      opts = {};
      opts[this.getAxisProperty()] = this.getShowAxisValue();
      return opts;
    };

    SlideScrollPanel.prototype.getHideAxisProperties = function() {
      var opts;
      opts = {};
      opts[this.getAxisProperty()] = this.getHideAxisValue();
      return opts;
    };

    SlideScrollPanel.prototype.$getWrapper = function() {
      var $wrap;
      $wrap = this.config.$wrap;
      return $wrap;
    };

    SlideScrollPanel.prototype.$getContent = function() {
      var $content;
      $content = this.config.$el;
      return $content;
    };

    SlideScrollPanel.prototype.$getEl = function() {
      return this.$getContent();
    };

    SlideScrollPanel.prototype.active = function(active) {
      var $wrap;
      $wrap = this.$getWrapper();
      if (active != null) {
        if (active === true) {
          this.enable();
        } else if (active === false) {
          this.disable();
        }
      } else {
        active = $wrap.hasClass(this.config.wrapActiveClass);
        return active;
      }
      return this;
    };

    SlideScrollPanel.prototype.resize = function() {
      var $container, $content, $wrap, height, width;
      $wrap = this.$getWrapper();
      $content = this.$getContent();
      $container = $wrap.parent();
      width = parseInt($container.css('width'), 10);
      height = parseInt($container.css('height'), 10);
      if (this.config.autoContentWidth) {
        $content.css({
          width: width
        });
      }
      if (this.config.autoContentHeight) {
        $content.css({
          height: height
        });
      }
      if (this.config.autoWrapWidth) {
        $wrap.css({
          width: width
        });
      }
      if (this.config.autoWrapHeight) {
        $wrap.css({
          height: height
        });
      }
      $content.css(this.getDesiredMarginStyles());
      return this;
    };

    SlideScrollPanel.prototype.showPanel = function(next) {
      var $wrap,
        _this = this;
      $wrap = this.$getWrapper();
      if ($wrap.is(':visible') === false) {
        this.resize();
        $wrap.css({
          opacity: 0
        });
        this.active(true);
        $wrap.prop(this.getHideAxisProperties()).css({
          opacity: 1
        });
      } else {
        this.active(true);
      }
      $wrap.stop(true, false).animate(this.getShowAxisProperties(), 400, function() {
        $(window).trigger('resize');
        return typeof next === "function" ? next() : void 0;
      });
      return this;
    };

    SlideScrollPanel.prototype.hidePanel = function(next) {
      var $wrap,
        _this = this;
      $wrap = this.$getWrapper();
      this.active(true);
      $wrap.stop(true, false).animate(this.getHideAxisProperties(), 400, function() {
        _this.active(false);
        $(window).trigger('resize');
        return typeof next === "function" ? next() : void 0;
      });
      return this;
    };

    SlideScrollPanel.prototype.enable = function(event) {
      var $content, $wrap, cachedProperties;
      $wrap = this.$getWrapper();
      $content = this.$getContent();
      if (this.leavePanelHelperTimer != null) {
        clearTimeout(this.leavePanelHelperTimer);
        this.leavePanelHelperTimer = null;
      }
      $wrap.addClass(this.config.wrapActiveClass).show();
      $wrap.css(this.getShowPositionStyles());
      cachedProperties = $wrap.data('cachedProperties');
      if (cachedProperties) {
        $wrap.prop(cachedProperties);
        $wrap.data('cachedProperties', null);
      }
      return this;
    };

    SlideScrollPanel.prototype.disable = function(event) {
      var $content, $wrap, apply, isAndroid,
        _this = this;
      $wrap = this.$getWrapper();
      $content = this.$getContent();
      if (this.leavePanelHelperTimer != null) {
        clearTimeout(this.leavePanelHelperTimer);
        this.leavePanelHelperTimer = null;
      }
      $wrap.removeClass(this.config.wrapActiveClass);
      apply = function() {
        if ($wrap.hasClass(_this.config.wrapActiveClass)) {
          return;
        }
        $wrap.data('cachedProperties', _this.getAxisProperties());
        $wrap.css(_this.getDesiredPositionStyles());
        return $wrap.prop(_this.getShowAxisProperties());
      };
      isAndroid = navigator.userAgent.toLowerCase().indexOf('android') !== -1;
      if ((event != null ? event.type : void 0) === 'touchend' && isAndroid) {
        $(document.body).one('click', apply);
      } else {
        apply();
      }
      return this;
    };

    SlideScrollPanel.prototype.enterPanelHelper = function(event) {
      this.enable(event);
      return this;
    };

    SlideScrollPanel.prototype.leavePanelHelperTimer = null;

    SlideScrollPanel.prototype.leavePanelHelper = function(event, opts) {
      var active,
        _this = this;
      if (opts == null) {
        opts = {};
      }
      active = this.active();
      if (active) {
        if (this.isTouchDevice()) {
          this.disable(event);
        } else if (event.type !== 'scroll' || (this.leavePanelHelperTimer != null)) {
          if (this.leavePanelHelperTimer != null) {
            clearTimeout(this.leavePanelHelperTimer);
            this.leavePanelHelperTimer = null;
          }
          if (opts.waited !== true) {
            this.leavePanelHelperTimer = setTimeout(function() {
              return _this.leavePanelHelper(event, {
                waited: true
              });
            }, this.config.disableDelay);
          } else {
            this.disable(event);
          }
        }
        /*
        			offset = @getOffset()
        			size =  @getSize()
        
        			# Fetch values
        			if @getInverse()
        				shown = offset is 0
        				over  = offset < size/2
        			else
        				shown = offset is size
        				over  = offset > size/2
        
        			# Same
        			if shown
        				# ignore
        
        			# Still active
        			else if over
        				@showPanel => @$getEl().trigger('slidescrollpanelin')
        
        			# No longer active
        			else
        				@hidePanel => @$getEl().trigger('slidescrollpanelout')
        */

      }
      return this;
    };

    return SlideScrollPanel;

  })();

  $.fn.slideScrollPanel = function(opts) {
    var $el, slideScrollPanel;
    if (opts == null) {
      opts = {};
    }
    $el = $(this);
    opts.$el = $el;
    slideScrollPanel = new SlideScrollPanel(opts);
    return $el;
  };

  return SlideScrollPanel;

});